<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

		if( !isset( $lookupTableLinks["naknada"] ) ) {
			$lookupTableLinks["naknada"] = array();
		}
		if( !isset( $lookupTableLinks["naknada"]["lica.naknada"] )) {
			$lookupTableLinks["naknada"]["lica.naknada"] = array();
		}
		$lookupTableLinks["naknada"]["lica.naknada"]["edit"] = array("table" => "lica", "field" => "naknada", "page" => "edit");
		if( !isset( $lookupTableLinks["iznos_naknade"] ) ) {
			$lookupTableLinks["iznos_naknade"] = array();
		}
		if( !isset( $lookupTableLinks["iznos_naknade"]["lica.iznos_naknade"] )) {
			$lookupTableLinks["iznos_naknade"]["lica.iznos_naknade"] = array();
		}
		$lookupTableLinks["iznos_naknade"]["lica.iznos_naknade"]["edit"] = array("table" => "lica", "field" => "iznos_naknade", "page" => "edit");
		if( !isset( $lookupTableLinks["vrsta_naknade"] ) ) {
			$lookupTableLinks["vrsta_naknade"] = array();
		}
		if( !isset( $lookupTableLinks["vrsta_naknade"]["lica.vrsta_naknade"] )) {
			$lookupTableLinks["vrsta_naknade"]["lica.vrsta_naknade"] = array();
		}
		$lookupTableLinks["vrsta_naknade"]["lica.vrsta_naknade"]["edit"] = array("table" => "lica", "field" => "vrsta_naknade", "page" => "edit");
		if( !isset( $lookupTableLinks["strucna_sprema"] ) ) {
			$lookupTableLinks["strucna_sprema"] = array();
		}
		if( !isset( $lookupTableLinks["strucna_sprema"]["lica.strucna_sprema_imenovanog"] )) {
			$lookupTableLinks["strucna_sprema"]["lica.strucna_sprema_imenovanog"] = array();
		}
		$lookupTableLinks["strucna_sprema"]["lica.strucna_sprema_imenovanog"]["edit"] = array("table" => "lica", "field" => "strucna_sprema_imenovanog", "page" => "edit");
}

?>